package aktbus.demo.advanced;

import aktbus.core.*;
import com.sun.xml.tree.*;
import org.w3c.dom.*;
import java.net.*;

/**
* This example demonstrates how to subclass AktMessage to get a
* message of customised format.
* In this example, we construct a simple subclass CustomisedMessage
* that is used to represent a quantified constraint.
* A constraint has a quantifier, a variable, and a body part.
*/

public class CustomisedMessage extends AktMessage
{
/*
* Constructor of the sample CustomisedMessage class
* @param sender
* @param receiver
* @param q	Quantifier of a constraint. A "forall" or "exists".
* @param v	The variable being quantified.
* @param b	The body of the constraint. Usually a predicate.
*/
public CustomisedMessage(String body)
	throws org.xml.sax.SAXException, Exception
{
super(body);
}

public CustomisedMessage(URL sender,URL receiver,String q,String v,String b)
	throws	java.net.MalformedURLException,
		java.lang.Exception
{
super();
Node n=createNode(q,v,b);						//create Node out of query
this.appendChild(createDOM(this,sender,receiver,n));			//create the Node and use it as the body
}

/**
* Create a Node to be inserted as the content.
*/
public Node createNode(String quantifier,String variable,String body)
{
ElementNode c,q,v,b;

c=(ElementNode)this.createElement("kraft:constraint");			//create nodes
q=(ElementNode)this.createElement("kraft:quantifier");
v=(ElementNode)this.createElement("kraft:variable");
b=(ElementNode)this.createElement("kraft:constraint-body");
c.appendChild(q);							//append nodes to form tree
c.appendChild(v);
c.appendChild(b);
q.appendChild(this.createTextNode(quantifier));
v.appendChild(this.createTextNode(variable));
b.appendChild(this.createTextNode(body));
return(c);								//return tree
}
}
