package aktbus.demo.advanced;

import aktbus.core.*;
import org.xml.sax.*;
import java.io.*;

/**
* Subclass of AktBusReceiver to receive a CustomisedMessage.
*/
public class CustomisedMessageReceiver extends AktBusReceiver
{

/**
* Constructor
*
* @param port	The port number to listen.
* @throws java.io.IOException	When an error occurs in I/O.
*/
public CustomisedMessageReceiver(int port)
	throws IOException
{
super(port);		//call superclass constructor
}

/**
* Construct a CustomisedMessage from a String.
* This overrides the default method in the superclass AktBusReceiver that returns a AktMessage.
*
* @param body	The string to parse.
* @throws org.xml.sax.SAXException	When the String body cannot be parsed as XML.
* @throws java.lang.Exception		When other general errors occur.
*/
protected AktMessage message_creator(String body)
	throws org.xml.sax.SAXException, Exception
{
return new CustomisedMessage(body);
}


}

