/**
* This example demonstrates how to access individual element in a CustomisedMessage.
*/


package aktbus.demo.advanced;


import java.net.*;
import org.w3c.dom.*;
import com.sun.xml.tree.*;

public class TestAccessCustomisedMessage
{

public static void main(String argv[])
{
CustomisedMessage c;

try	{
	//
	// creates a CustomisedMessage
	//
	c=new CustomisedMessage(new URL("http://dummy.host/me"),new URL("http://dummy.host/you"),"forall","var(a)","a predicate");
	c.write(System.out);

	//
	// use find_element_node to look for ElementNode in the XML document
	//
	ElementNode content_node=c.find_element_node("kraft:constraint");
	ElementNode quantifier_node=c.find_element_node(content_node,"kraft:quantifier");	//search from content_node
	ElementNode variable_node=c.find_element_node(content_node,"kraft:variable");
	ElementNode body_node=c.find_element_node(content_node,"kraft:constraint-body");

	//
	// use get_first_child_node to look for text node of the type TEXT_NODE under each ElementNode
	// then use getNodeValue to retrieve its value
	//
	System.out.println("quantifier:"+c.get_first_child_node(quantifier_node,org.w3c.dom.Node.TEXT_NODE).getNodeValue());
	System.out.println("variable:"+c.get_first_child_node(variable_node,org.w3c.dom.Node.TEXT_NODE).getNodeValue());
	System.out.println("body:"+c.get_first_child_node(body_node,org.w3c.dom.Node.TEXT_NODE).getNodeValue());
	} catch (Exception e)
		{
		System.err.println(e.toString());
		}
}
}

