package aktbus.demo.applet;
//
// thread for receiving an AktMessage through sockets
//
import aktbus.core.*;
import java.awt.*;
import java.io.*;
import org.xml.sax.*;

public class ReceiverThread extends Thread
{
AktBusReceiver receiver;
TextArea text_area;

//
// constructor
//
public ReceiverThread(int port,TextArea t) throws IOException
{
super();							//call superclass constructor, i.e. Thread
receiver=new AktBusReceiver(port);				//create the AktBusReceiver object
text_area=t;							//save TextArea object reference
text_area.setText("Waiting for incoming connection...\n");	//set textarea message
}

//
// thread execution
//
public void run()
{
AktMessage m;
StringWriter sw;
boolean flag=true;

while (flag)
	{
	try	{
		m=receiver.receive_message();			//receive with timeout
		sw=new StringWriter();				//prepare string as a buffer
		m.write(sw);					//write XML message into buffer
		text_area.append(sw.toString());		//display buffer in TextArea
		} catch (IOException e)
			{
			System.out.println("*** "+e.toString());
			flag=false;
			}
		catch (SAXException e)
			{
			System.out.println("*** "+e.toString());
			}
		catch (Exception e)
			{
			System.out.println("*** "+e.toString());
			}
	}
}
}


