package aktbus.demo.applet;

//
// a testing applet receiving an AktMessage w/ GUI
//
//
import aktbus.core.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class TestReceiveApplet extends Applet implements ActionListener
{
TextField port_field;
Label port_label,message_label;
Button wait_button,clear_button;
TextArea message_area;

public void init()
{
GridBagConstraints c;
GridBagLayout layout;

layout=new GridBagLayout();
this.setLayout(layout);
c=new GridBagConstraints();


port_field=new TextField(40);
port_field.setEditable(true);
message_area=new TextArea();
message_area.setEditable(false);

port_label=new Label("Port No.:");
message_label=new Label("Message Received:");

wait_button=new Button("Wait for message");
wait_button.addActionListener(this);
wait_button.setActionCommand("wait");
clear_button=new Button("Clear");
clear_button.addActionListener(this);
clear_button.setActionCommand("clear");

put_component(layout,c,port_label,0,0);
put_component(layout,c,port_field,1,0);
put_component(layout,c,message_label,0,2);
put_component(layout,c,message_area,1,2);
put_component(layout,c,wait_button,0,3);
put_component(layout,c,clear_button,1,3);
}

private void put_component(GridBagLayout layout,GridBagConstraints c,Component p,int x,int y)
{
c.gridx=x;
c.gridy=y;
layout.setConstraints(p,c);
add(p);
}


public void start()
{
port_field.setText("");
message_area.setText("");
}



public void actionPerformed(ActionEvent e)
{
String c;

c=e.getActionCommand();

if (c.equals("clear"))
	{
	port_field.setText("");
	message_area.setText("");
	}
else if (c.equals("wait"))
	{
	wait_for_message();
	}
}

public void wait_for_message()
{
AktBusReceiver a;
AktMessage m;
StringWriter sw;


try	{
	a=new AktBusReceiver(Integer.parseInt(port_field.getText()));
	message_area.setText("Waiting for incoming message...");
	m=a.receive_message(5,null);
	sw=new StringWriter();
	m.write(sw);
	message_area.append(sw.toString());
	} catch (Exception e)
		{
		message_area.append("ERROR:"+e.toString());
		}
}

}
