package aktbus.demo.applet;

//
// applet sending an AktMessage
//

import aktbus.core.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class TestSendAppletWithProxy extends Applet implements ActionListener
{
TextField sender_field,receiver_field,message_field,proxy_field;
Label sender_label,receiver_label,message_label,rdf_label,proxy_label;
Button send_button,clear_button;
TextArea akt_message;
String sender="",receiver="",message="",proxy="";
int timeout=0;

//
//initialize applet
//
public void init()
{
GridBagConstraints c;
GridBagLayout layout;

layout=new GridBagLayout();
this.setLayout(layout);
c=new GridBagConstraints();

sender=getParameter("default_sender");
receiver=getParameter("default_receiver");
proxy=getParameter("default_proxy");
message=getParameter("default_message");
timeout=Integer.parseInt(getParameter("network_timeout"));

sender_field=new TextField(40);
receiver_field=new TextField(40);
proxy_field=new TextField(40);
message_field=new TextField(40);
akt_message=new TextArea();

sender_field.setEditable(true);
receiver_field.setEditable(true);
proxy_field.setEditable(true);
message_field.setEditable(true);

System.out.println(receiver);

sender_label=new Label("Sender URI:");
receiver_label=new Label("Receiver URI:");
proxy_label=new Label("Proxy URI:");
message_label=new Label("Message Content:");
rdf_label=new Label("AKT Message:");

send_button=new Button("Send");
send_button.addActionListener(this);
send_button.setActionCommand("send");
clear_button=new Button("Clear");
clear_button.addActionListener(this);
clear_button.setActionCommand("clear");

put_component(layout,c,sender_label,0,0);
put_component(layout,c,sender_field,1,0);
put_component(layout,c,receiver_label,0,1);
put_component(layout,c,receiver_field,1,1);
put_component(layout,c,proxy_label,0,2);
put_component(layout,c,proxy_field,1,2);
put_component(layout,c,message_label,0,3);
put_component(layout,c,message_field,1,3);
put_component(layout,c,send_button,0,4);
put_component(layout,c,clear_button,1,4);
put_component(layout,c,rdf_label,0,5);
put_component(layout,c,akt_message,1,5);
}

private void put_component(GridBagLayout layout,GridBagConstraints c,Component p,int x,int y)
{
c.gridx=x;
c.gridy=y;
layout.setConstraints(p,c);
add(p);
}

//
//start running applet
//
public void start()
{
sender_field.setText(sender);
receiver_field.setText(receiver);
proxy_field.setText(proxy);
message_field.setText(message);
akt_message.setText("");
}


//
//public void stop()
//{
//}
//
//public void destroy()
//{
//}
//


//
//listener for button press
//
public void actionPerformed(ActionEvent e)
{
String c;

c=e.getActionCommand();

if (c.equals("clear"))
	{
	sender_field.setText("");
	receiver_field.setText("");
	message_field.setText("");
	}
else if (c.equals("send"))
	{
	send();
	}
}

//
//handling the "send" button
//
public void send()
{
AktMessage a;
StringWriter sw;
URL proxy_uri;

try	{
	a=new AktMessage(sender_field.getText(),receiver_field.getText(),message_field.getText());
	sw=new StringWriter();
	a.write(sw);
	akt_message.setText(sw.toString());
	if (proxy_field.getText().length()==0)
		{
		a.send(timeout);
		}
	else	{
		proxy_uri=new URL(proxy_field.getText());
		a.send(proxy_uri,timeout);
		}
	} catch (Exception e)
		{
		akt_message.append(e.toString());
		}
}

}
