package aktbus.demo.simple;

import aktbus.core.*;
import java.lang.*;
import java.net.*;
import org.xml.sax.*;
import com.sun.xml.tree.*;

/**
* This JAVA program demonstrates different ways to construct an AktMessage
* by different constructors in the class.
* To see how you can subclass AktMessage to form a new class, see...
*/


public class TestCreateAktMessage
{
public static void main(String argv[])
{
URL sender,receiver;

try	{
	sender=new URL("http://quail.csd.abdn.ac.uk/akt/sender");	//dummy sender & receiver
	receiver=new URL("http://quail.csd.abdn.ac.uk/akt/receiver");
	method1(sender,receiver);
	method2(sender,receiver);
	} catch (Exception e)
		{
		System.err.println(e.toString());
		}
}


/**
* Create an AktMessage by using a simple String as the message content.
*/
public static void method1(URL sender,URL receiver)
	throws Exception
{
String c="this is a plain text";
AktMessage a;

a=new AktMessage(sender,receiver,c);
a.write(System.out);
}


/**
* Create an AktMessage by parse a String into an XML subtree.
*/
public static void method2(URL sender,URL receiver)
	throws Exception
{
AktMessage a;
String c;

c="<kraft:constraint><kraft:quantifier>forall</kraft:quantifier><kraft:body>body-here</kraft:body></kraft:constraint>";
a=new AktMessage(sender,receiver,true,c);	//try to parse message content as XML
a.write(System.out);				//print AKT message to stdout
}

}

