package aktbus.demo.simple;
import aktbus.core.*;

//
// test receiving an AktMessage and piggy-pack a reply
//
import java.io.*;
import org.xml.sax.*;

public class TestPiggyPackedReceiver
{
public static void main(String argv[])
{
AktBusReceiver r;
AktMessageWithExtra m;

if (argv.length!=1)
	{
	System.err.println("usage: java TestPiggyPackedReceiver <port>");
	System.exit(0);
	}
try	{
	r=new AktBusReceiver(Integer.parseInt(argv[0]));		//get port no.
	System.out.println("waiting for AktMessage at port:"+argv[0]);
	m=r.receive_with_extra();						//wait & receive
	System.out.println("===message received===");
	m.message.write(System.out);
	if (m.message.get_sender()==null)
		{
		System.out.println("===sending piggy-packed reply===");
		AktMessage x=new AktMessage(null,null,false,"hello. this is a reply");
		x.write(System.out);
		x.ugly_write(m.out_stream);
		}
	m.close_connection();
	} catch (SAXException e)
		{
		System.err.println("Error in parsing XML...");
		System.err.println(e.toString());
		}
	catch (IOException e)
		{
		System.err.println("Error in I/O...");
		System.err.println(e.toString());
		}
	catch (Exception e)
		{
		System.err.println("Other error...");
		System.out.println("ERROR in receiving");
		}
}

}

