package aktbus.kqml.demo;
import aktbus.kqml.*;
import com.sun.xml.tree.*;
import org.xml.sax.*;
import java.io.*;
import java.util.*;

/**
* A simple demo that composes & decomposed a KqmlMessage.
*/
public class TestKqmlCompose
{
public static void main(String argv[])
{
KqmlMessage k;
Map kp;
Iterator i;
Map param_map;
XmlDocument x;

try	{
	//
	// create an XML document that holds the content
	//
	String content_string="<x><y>hello</y><z>there</z></x>";
	x=XmlDocument.createXmlDocument(new InputSource(new StringReader(content_string)),false);
	//
	// create a HashMap of KqmlParam, put KqmlParam into HashMap
	//
	kp=new HashMap();
	kp.put("language",new KqmlParam("language","prolog"));
	kp.put("sender",new KqmlParam("sender","http://me/me"));
	kp.put("receiver",new KqmlParam("receiver","http://you/you"));
	kp.put("content",new KqmlParam("content",x));
	//
	// create KqmlMessage with "tell" performative and parameters
	// then print KqmlMessage to screen
	//
	k=new KqmlMessage("tell",kp);
	System.out.println("KQML message:");
	k.write(System.out);
	//
	// get KqmlParam Map, extract content value
	//
	param_map=k.get_parameter_map();
	KqmlParam content=(KqmlParam)param_map.get("content");	//find content KqmlParam using "content" as the key
	System.out.println("Content of KQML message:");
	System.out.println(k.get_subtree_text((ElementNode)(content.value)));	//get String under node
	} catch (Exception e)
		{
		System.out.println("ERROR:"+e.toString());
		}
}

}

