public class BounceAgent
{
public static void main(String argv[])
{
int port=0;
boolean bounce_flag=true,verbose_flag=false;
AktBusReceiver ar;
AktMessage am;
int i;


try	{
	port=Integer.parseInt(argv[0]);			//get port no. from command line argument
	for (i=1;i<argv.length;i++)
		{
		if (argv[i].equalsIgnoreCase("-nb"))	//check the no-bounce flag
			bounce_flag=false;
		else if (argv[i].equalsIgnoreCase("-v"))
			verbose_flag=true;
		else throw new Exception();
		}
	ar=new AktBusReceiver(port);			//create AktBusReceiver
	while (true)					//loops
		{
		if (verbose_flag)
			{
			System.out.println("Waiting at port <"+port+">...");
			if (!bounce_flag)
				System.out.println("bouncing OFF...");
			}
		am=ar.receive_message();		//wait & receive an AKT message
		if (verbose_flag)
			am.ugly_write();		//write to screen
		if (bounce_flag)
			bounce(am);			//bounce message back
		}
	} catch (Exception e)
		{
		System.err.println("usages: BounceAgent <port no.> [-nb] [-v]");
		System.err.println("        -nb: no bouncing, only receive");
		System.err.println("        -v:  verbose, print out received message");
		}
}

public static void bounce(AktMessage m)
{
String sender,receiver,content;
AktMessage n;

try	{
	sender=m.get_sender();
	receiver=m.get_receiver();
	content=m.get_simple_message();
	n=new AktMessage(receiver,sender,content);
	n.send();
	System.out.println("bounced!");
	} catch (Exception e)
		{
		System.out.println(e.toString());
		}
}

}


