:- use_module('../src/abslm').		%use the A-Bus service library module
:- use_module(library(lists)).
:- use_module(library(sockets)).

%
%%% This is a simple program to simulate a problem-solving agent.
%%% It registers its problem-solving competences (capacities/interfaces)
%%% (currently in the form of some atom predicate) with the designated
%%% linda gateway, using the aktbus and xml-rdf wrapped messages.


%%%
%%% Port is that of the linda_gateway on the specified machine.
%%%

register(Port,Content) :-
	current_host(Host),
	name(Host,S), % convert to string for sending:

	append("http://",S,Sender), % add http prefix

	% Linda_gate_host is hostname of linda_gateway process:
	Linda_gate_host="http://kerrera.aiai.ed.ac.uk:", 

	name(Port,P),
	append(Linda_gate_host,P,Rec), 
	%write(Rec),nl,
	compose_message(Sender,Rec,Content,Msg),
	send_message(Msg).

