package aktbus.core;
import java.io.*;
import java.net.*;

/**
* The <em>AktMessageWithExtra</em> class is used to encapsulate information in
* an HTTP request, which usually contains a request path and
* an <em>AktMessage</em> in its body.
*
* In additional to this, it contains 3 other optional fields:
* a client socket, an input stream & an output stream.
* These 3 optional fields are only valid when the sender expects a piggy-packed
* reply.
*/

public class AktMessageWithExtra
{

/**
* The <em>AktMessage</em> object in a HTTP request.
*/
public AktMessageInterface message;

/**
* The request path in a HTTP request.
*/
public String path;

/**
* The client socket where the connection is made.
*/
Socket socket;

/**
* The input stream where the incoming request is read.
*/
public BufferedReader in_stream;

/**
*The output stream for send a piggy-packed  reply.
*/
public PrintWriter out_stream;


/**
* Close all socket & streams.
*/
public void close_connection()
{
try	{
	in_stream.close();
	} catch (Exception e)
		{
		}
try	{
	out_stream.close();
	} catch (Exception e)
		{
		}
try	{
	socket.close();
	} catch (Exception e)
		{
		}
} //end method close_connection

} //end class AktMessageWithConnection

