// Demonstrates two ways of receiving an AktMessage object

import aktbus.core.*;
import aktbus.core.fipa.*;
import java.io.*;
import org.xml.sax.*;

public class ReceiveAktMessage
{
public static void main(String argv[])
{
AktBusReceiver a;

if (argv.length!=1)
	{
	System.err.println("usage: java TestAktBusReceiver <port>");
	System.exit(0);
	}
try	{
	a=new AktBusReceiver(Integer.parseInt(argv[0]));
	 
	System.out.println("waiting for AktMessage at port: "+argv[0]);
	AktMessage m = a.receive_message();
	System.out.println("CONTENT: " + m.get_simple_message());

	System.out.println("waiting for AktMessage at port: "+argv[0]);
	m = (AktMessage)a.receive(0, java.lang.Class.forName("aktbus.core.AktMessage")).message;
	System.out.println("CONTENT: " + m.get_simple_message());

	}
	catch (IOException e)
		{
		System.err.println("Error in I/O...");
		System.err.println(e.toString());
		}
	catch (Exception e)
		{
		System.err.println("Other error...");
		System.out.println(e.toString());
		}
}

}

