// Demonstrates two ways of receiving a RDFFipaMessage through an 
// AktBusReceiver object.

import aktbus.core.*;
import aktbus.core.fipa.*;
import java.io.*;

public class ReceiveFipaMessage
{
public static void main(String argv[])
{
AktBusReceiver a;

if (argv.length!=1)
	{
	System.err.println("usage: java TestFipaReceiver <port>");
	System.exit(0);
	}
try	{
	a=new AktBusReceiver(Integer.parseInt(argv[0]));		//get port no.
	System.out.println("waiting for RDFFipaMessage at port:"+argv[0]);
	RDFFipaMessage r = a.receive_RDFFipaMessage();
	System.out.println("FIPA CONTENT: " + r.get_simple_message());

	System.out.println("waiting for RDFFipaMessage at port:"+argv[0]);
	r= (RDFFipaMessage)a.receive(0, java.lang.Class.forName("aktbus.core.fipa.RDFFipaMessage")).message;
	System.out.println("CONTENT: " + r.get_simple_message());
	}
	catch (IOException e)
		{
		System.err.println("Error in I/O...");
		System.err.println(e.toString());
		}
	catch (Exception e)
		{
		System.err.println("Other error...");
		System.out.println(e.toString());
		}
}

}

