import aktbus.core.*;

import java.io.*;
import java.util.*;
import java.net.*;

import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;
import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;

public class TestRDFMessage {

public static void main(String argv[]) {

    if (argv.length!=1)
	{
	    System.err.println("usage: java TestRDFMessage <receiver>");
	    System.exit(0);
	}
	try {

	//Set up file reader to read aktmessage
	FileReader in = new FileReader("aktexample");
	StringWriter sw2 = new StringWriter();
	int temp = in.read();
	while (temp != -1) {
	    sw2.write(temp);
	    temp = in.read();
	}
	sw2.close();

	RDFAktMessage msg = new RDFAktMessage(sw2.toString());
	sw2 = new StringWriter();
	msg.write(sw2);
	sw2.close();	
	System.out.println("\n\n" + sw2.toString());

	System.out.println("\nReceiver: " + msg.get_receiver()); 
	System.out.println("Sender: " + msg.get_sender());
	System.out.println("Content: " + msg.get_simple_message());


	System.out.println("\nReplacing receiver, sender and content with strings...");
	msg.set_receiver("http://hawk.csd.abdn.ac.uk");
	msg.set_sender("http://new.sender.com:1234");
	msg.set_simple_message("My new content");
	System.out.println("Receiver: " + msg.get_receiver()); 
	System.out.println("Sender: " + msg.get_sender());
	System.out.println("Content: " + msg.get_simple_message());

	System.out.println("\nReplacing sender and receiver with URIs...");
	msg.set_sender(new URL("http://sol.csd.abdn.ac.uk:1234"));
	msg.set_receiver(new URL(argv[0]));
	System.out.println("Receiver: " + msg.get_receiver()); 
	System.out.println("Sender: " + msg.get_sender());
	    System.out.println("Sending message to " + msg.get_receiver());
	msg.send();    

	sw2 = new StringWriter();
	msg.ugly_write(sw2);
	sw2.close();	
	System.out.println("\n\n" + sw2.toString());

	sw2 = new StringWriter();
	msg.pretty_write(sw2);
	sw2.close();	
	System.out.println("\n\n" + sw2.toString());


	}
	catch (IOException e)
		{
		System.err.println("Error in I/O...");
		System.err.println(e.toString());
		}
	 catch (Exception e)
		{
		System.err.println("***ERROR: "+e.toString());
		}
}

}
