package aktbus.core;

import com.hp.hpl.mesa.rdf.jena.common.ErrorHelper;
import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;
import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;
import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;

public class AKTVOCAB {

  protected static final String uri ="http://www.csd.abdn.ac.uk/~khui/akt/aktbus.xml#";

    /** returns the URI for this schema
     * @return the URI for this schema
     */
    public static String getURI() {
          return uri;
    }

    // Resources
    static String nContainer = "Container";
    public static Resource Container; 
    static String nSimpleHeader = "SimpleHeader";
    public static Resource SimpleHeader;
    static String nSimpleContent = "SimpleContent";
    public static Resource SimpleContent;

    // Properties
    static String nid = "id";
    public static Property id;
    static String nhasHeader = "hasHeader";
    public static Property hasHeader;
    static String nhasContent = "hasContent";
    public static Property hasContent;
    static String nhasDateString = "hasDateString";
    public static Property hasDateString;
    static String nhasTimeString = "hasTimeString";
    public static Property hasTimeString;
    static String nhasSenderURI = "hasSenderURI";
    public static Property hasSenderURI;
    static String nhasReceiverURI = "hasReceiverURI";
    public static Property hasReceiverURI;
    static String nhasSimpleMessage = "hasSimpleMessage";
    public static Property hasSimpleMessage;


    static {
	try {
	    Container = new ResourceImpl(uri, nContainer);
	    SimpleHeader = new ResourceImpl(uri, nSimpleHeader);
	    SimpleContent = new ResourceImpl(uri, nSimpleContent);
	    id = new PropertyImpl(uri, nid);
	    hasHeader = new PropertyImpl(uri, nhasHeader);
	    hasContent = new PropertyImpl(uri, nhasContent);
	    hasDateString = new PropertyImpl(uri, nhasDateString);
	    hasTimeString = new PropertyImpl(uri, nhasTimeString);
	    hasSenderURI = new PropertyImpl(uri, nhasSenderURI);
	    hasReceiverURI = new PropertyImpl(uri, nhasReceiverURI);
	    hasContent = new PropertyImpl(uri, nhasContent);
	    hasSimpleMessage = new PropertyImpl(uri, nhasSimpleMessage);
	}
	catch (Exception e) {
            ErrorHelper.logInternalError("RDF", 1, e);
        }
    }
}
